/* XToride, ondemand.c */

#include <X11/Xlib.h>
#include <math.h>
#include <stdlib.h>
#include "headers.h"

extern	Display		*d;
extern	Window		root, w, wf;
extern	GC		gcM;
extern	Colormap	cmap;
extern	Pixmap		mountain;

struct zahyou	toride[2];	/* Ȥֲս Xɸ(ü), ɸ */
extern	unsigned long	bg_pixel;


/* "Quit"ܥΥ٥Ƚ */
void
QuitButton(quit, event, QuitFlag)
    Window		quit;
    XEvent		*event;
    unsigned short	*QuitFlag;
{
    XColor	tc;

    switch (event->type) {
    case ButtonPress:
	if (event->xbutton.button == 1)
	    exit(1);
	break;
    case EnterNotify:
	*QuitFlag = 0xffff;
	DrawQuitButton(quit, *QuitFlag);
	break;
    case LeaveNotify:
	*QuitFlag = 0;
	DrawQuitButton(quit, *QuitFlag);
	break;
    case Expose:
	if (event->xexpose.count == 0)
	    DrawQuitButton(quit, *QuitFlag);
	break;
    }
}


/* "Quit"ܥ */
void
DrawQuitButton(quit, QuitFlag)
    Window		quit;
    unsigned short	QuitFlag;
{
    XColor	tc;
    GC		gc;
    Font	font;

    gc	= XCreateGC(d, root, 0, NULL);

    tc.red = tc.green = tc.blue = 0xffff ^ QuitFlag;
    XAllocColor(d, cmap, &tc);
    XSetForeground(d, gc, tc.pixel);
    XFillRectangle(d, quit, gc, 0, 0, QWIDTH, QHEIGHT);

    tc.red = tc.green = tc.blue = 0 ^ QuitFlag;
    font   = XLoadFont(d, "lucidasanstypewriter-bold-14");
    XAllocColor(d, cmap, &tc);
    XSetForeground(d, gc, tc.pixel);
    XSetFont(d, gc, font);
    XDrawString(d, quit, gc, 2, 15, "Quit", 4);
}


/* ϷȤȤǤ */
void
CreateStage(void)
{
    int r, pr, mh, pmh, x;

    r  = 0;
    pr = 0;
    pmh = HEIGHT / 4;
    toride[0].x = (WIDTH / 4    ) - ((float)rand() / RAND_MAX * (WIDTH / 10));
    toride[1].x = (WIDTH / 4 * 3) + ((float)rand() / RAND_MAX * (WIDTH / 10));

    XDrawLine(d, mountain, gcM, 0, (HEIGHT / 4), 0, (HEIGHT / 2 - 1));

    for (x = 1; x < WIDTH; x++) {
	if (toride[0].x < x && x < toride[0].x + 16) {
	    mh = pmh;
	    toride[0].y = mh + MHOME;
	} else if (toride[1].x < x && x < toride[1].x + 16) {
	    mh = pmh;
	    toride[1].y = mh + MHOME;
	} else do {
	    do {
		r = pr + (int)((float)rand() / RAND_MAX * 4 - 2);
	    } while(r < -4 || 6 <= r);
	    pr = r;
	    mh = pmh + r;
	} while (mh < 0 || (HEIGHT / 5 * 2) <= mh);
	XDrawLine(d, mountain, gcM, x, mh, x, (HEIGHT / 2 - 1));
	pmh = mh;
    }
}


/* ϷȤȤǤ */
void
DrawStage(PtorideL, PtorideR, sflag)
    Pixmap	PtorideL, PtorideR;
    char	sflag;
{
    GC	gc;

    gc	= XCreateGC(d, root, 0, NULL);

    XCopyArea(d, mountain, w, gc, 0, 0, WIDTH, HEIGHT / 2, 0, MHOME);
    if ((sflag & 0x20) == 0)
	XCopyArea(d, PtorideL, w, gc,
		0, 0, 16, 16, toride[0].x, toride[0].y - 16);
    if ((sflag & 0x02) == 0)
	XCopyArea(d, PtorideR, w, gc,
		0, 0, 16, 16, toride[1].x, toride[1].y - 16);
}


/* Ȥǳޤ */
void
DrawTorideUp(Tup, oangle, nangle, i)
    Window	Tup;
    int		oangle, nangle, i;
{
    XPoint	*ohw, *nhw, dhw[4];
    XColor	tc;
    GC		gc;

    gc	= XCreateGC(d, root, 0, NULL);

    ohw = CreateCannon(oangle);
    nhw = CreateCannon(nangle);

    XSetForeground(d, gc, bg_pixel);
    if (oangle < nangle) {
	dhw[0].x = ohw[2].x;	dhw[0].y = ohw[2].y;
	dhw[1].x = ohw[3].x;	dhw[1].y = ohw[3].y;
	dhw[2].x = nhw[3].x;	dhw[2].y = nhw[3].y;
	dhw[3].x = nhw[2].x;	dhw[3].y = nhw[2].y;
    } else {
	dhw[0].x = ohw[0].x;	dhw[0].y = ohw[0].y;
	dhw[1].x = ohw[1].x;	dhw[1].y = ohw[1].y;
	dhw[2].x = nhw[1].x;	dhw[2].y = nhw[1].y;
	dhw[3].x = nhw[0].x;	dhw[3].y = nhw[0].y;
    }
    XFillPolygon(d, Tup, gc, dhw, 4, Convex, CoordModeOrigin);

    tc.red = 0xffff * i; tc.green = 0xffff; tc.blue = 0xffff * (i ^ 1);
    XAllocColor(d, cmap, &tc);
    XSetForeground(d, gc, tc.pixel);
    XFillArc(d, Tup, gc, TWIDTH / 4, THEIGHT * 2 / 3 - TWIDTH / 4 - 2,
				TWIDTH / 2, TWIDTH / 2, 0, 180 * 64);
    XFillPolygon(d, Tup, gc, nhw, 4, Convex, CoordModeOrigin);
}


/* ˤɸ׻ */
XPoint *CreateCannon(angle)
    int	angle;
{
    XPoint	*hw;
    double	rangle0, rangle1, rangle2;

    rangle0 =        angle  * RAD;
    rangle1 = ( 90 + angle) * RAD;
    rangle2 = (270 + angle) * RAD;

    hw = (XPoint *)malloc(sizeof(XPoint) * 4);
    ( *hw     ).x = THWL                *  cos(rangle0)
		+ THWW * cos(rangle1) + TWIDTH / 2;
    ( *hw     ).y = THWL                * -sin(rangle0)
		- THWW * sin(rangle1) + THEIGHT * 2 / 3 - 2;
    (*(hw + 1)).x = (THWL - TWIDTH / 4) *  cos(rangle0)
		+ THWW * cos(rangle1) + TWIDTH / 2;
    (*(hw + 1)).y = (THWL - TWIDTH / 4) * -sin(rangle0)
		- THWW * sin(rangle1) + THEIGHT * 2 / 3 - 2;
    (*(hw + 2)).x = (THWL - TWIDTH / 4) *  cos(rangle0)
		+ THWW * cos(rangle2) + TWIDTH / 2;
    (*(hw + 2)).y = (THWL - TWIDTH / 4) * -sin(rangle0)
		- THWW * sin(rangle2) + THEIGHT * 2 / 3 - 2;
    (*(hw + 3)).x = THWL                *  cos(rangle0)
		+ THWW * cos(rangle2) + TWIDTH / 2;
    (*(hw + 3)).y = THWL                * -sin(rangle0)
		- THWW * sin(rangle2) + THEIGHT * 2 / 3 - 2;

    return hw;
}


/* ®٥ */
void
DrawPowerGauge(pg, velocity, i)
    Window	pg;
    int		velocity, i;
{
    XPoint	hw[4];
    XColor	tc;
    GC		gc;

    gc	= XCreateGC(d, root, 0, NULL);

    XSetForeground(d, gc, bg_pixel);
    XFillRectangle(d, pg, gc,
	((TWIDTH - 12) * velocity / PMAX) * (1 - i), 0,
	(TWIDTH - 12) * (PMAX - velocity) / PMAX, THEIGHT / 4 - 12);

    tc.red = 0xffff; tc.green = 0; tc.blue = 0;
    XAllocColor(d, cmap, &tc);
    XSetForeground(d, gc, tc.pixel);
    XFillRectangle(d, pg, gc,
	((TWIDTH - 12) - (TWIDTH - 12) * velocity / PMAX) * i, 0,
	(TWIDTH - 12) * velocity / PMAX, THEIGHT / 4 - 12);
}


/* Key */
void
KeyHandler(xkey, type, cflag, sflag, rflag)
    XKeyEvent	*xkey;
    int		type;
    char	*cflag, *sflag, *rflag;
{
    KeySym	kbind[10], ksym;	/* Х,  */
    int		i;

    kbind[0] = SHOOT_L;			kbind[1] = SHOOT_R;
    kbind[2] = ANGLE_UP_L;		kbind[3] = ANGLE_UP_R;
    kbind[4] = VELOCITY_UP_L;		kbind[5] = VELOCITY_UP_R;
    kbind[6] = VELOCITY_DOWN_L;		kbind[7] = VELOCITY_DOWN_R;
    kbind[8] = ANGLE_DOWN_L;		kbind[9] = ANGLE_DOWN_R;

    ksym = XLookupKeysym(xkey, 0);
    if ((*sflag & 0x22) == 0) {
	for (i = 0; i <= 1; i++) {
	    if (type == KeyPress) {
		if (ksym == kbind[0 + i])
		    *sflag |= 0x1 << (1 - i) * 4;
		else if (ksym == kbind[2 + i])
		    *cflag |= 0x8 << (1 - i) * 4;
		else if (ksym == kbind[4 + i])
		    *cflag |= 0x1 << (1 - i) * 4;
		else if (ksym == kbind[6 + i])
		    *cflag |= 0x2 << (1 - i) * 4;
		else if (ksym == kbind[8 + i])
		    *cflag |= 0x4 << (1 - i) * 4;
	    } else {
		if (ksym == kbind[0 + i])
		    *sflag &= 0xe << (1 - i) * 4;
		else if (ksym == kbind[2 + i])
		    *cflag &= 0x7 << (1 - i) * 4;
		else if (ksym == kbind[4 + i])
		    *cflag &= 0xe << (1 - i) * 4;
		else if (ksym == kbind[6 + i])
		    *cflag &= 0xd << (1 - i) * 4;
		else if (ksym == kbind[8 + i])
		    *cflag &= 0xb << (1 - i) * 4;
	    }
	} /* for (i=0; i<=1; i++) */
    } else if ((*rflag & 0x01) && ksym == REPLAY)
	*rflag |= 0x02;
    if (ksym == QUIT)
	exit(1);
}


/* ϤѲ */
void
Wind(wind, windc)
    double	*wind, *windc;
{
    double	windt;

    windt = (double)rand() / RAND_MAX / 5 - 0.1;
    if (0 < *wind)
	windt -= 0.02;
    else if (*wind < 0)
	windt += 0.02;

    *windc += windt;
    if (0.2 < *windc)
	*windc =  0.2;
    else if (*windc < -0.2)
	*windc = -0.2;

    *wind += *windc;
    if (3 < *wind)
	*wind =  3;
    else if (*wind < -3)
	*wind = -3;

    DrawFlag(*wind);
}


/* () */
void
DrawFlag(wind)
    double	wind;
{
    XPoint	p[3];
    XColor	tc;
    GC		gc;

    gc	= XCreateGC(d, root, 0, NULL);

    p[0].x = WFWIDTH / 2;
    p[0].y = 10;
    p[1].x = WFWIDTH / 2;
    p[1].y = 40;
    p[2].x = WFWIDTH / 2 + sin(M_PI / 2 * wind / 3) * 30;
    p[2].y = 25 + cos(M_PI / 2 * wind / 3) * 30;

    XClearWindow(d, wf);

    tc.red = 0xc000; tc.green = 0xd000; tc.blue = 0xf000;
    XAllocColor(d, cmap, &tc);
    XSetForeground(d, gc, tc.pixel);
    XFillRectangle(d, wf, gc, WFWIDTH / 2 - 2, 10, 5, WFHEIGHT - 10);

    tc.red = 0xf000; tc.green = 0xf000; tc.blue = 0xa000;
    XAllocColor(d, cmap, &tc);
    XSetForeground(d, gc, tc.pixel);
    XFillPolygon(d, wf, gc, p, 3, Convex, CoordModeOrigin);
}
