/* XToride, xtoride.c */

#include <sys/types.h>
#include <X11/Xlib.h>
#include <math.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "torideL.xbm"
#include "torideR.xbm"
#include "headers.h"

Display		*d;
Window		root, w, wf;
GC		gcM, gcP;	/* ¸ߤ뻳, ˤƤε */
Colormap	cmap;
Pixmap		mountain;	/* ưŪѲϷ */

extern	struct zahyou	toride[2];
int		bstage[2];	/* ʳ */
unsigned long	bg_pixel;	/* طʤΥԥ */


/* ᥤ롼 */
int
main(argc, argv)
    int		argc;
    char	*argv[];
{
    Window		quit, Tup[2], pg[2];
    Pixmap		PtorideL, PtorideR;
    XColor		tc;
    GC			gc;
    unsigned long	mpixel;		/* ϷΥԥ(Ƚ) */
    unsigned short	QuitFlag;	/* QuitܥΥե */
    int			screen;

    srand(getpid());
    signal(SIGALRM, al_handler);

    d	   = XOpenDisplay("");
    root   = DefaultRootWindow(d);
    screen = DefaultScreen(d);
    gc	   = XCreateGC(d, root, 0, NULL);
    gcM	   = XCreateGC(d, root, 0, NULL);
    gcP	   = XCreateGC(d, root, 0, NULL);
    cmap   = DefaultColormap(d, screen);
    QuitFlag = 0;

    tc.red = 0; tc.green = 0x8000; tc.blue = 0xa000;
    XAllocColor(d, cmap, &tc);
    bg_pixel = tc.pixel;
    w = XCreateSimpleWindow(d, root, 10, 10, WIDTH, HEIGHT, BORDER,
			BlackPixel(d, screen), bg_pixel);
    quit = XCreateSimpleWindow(d, w, QX, QY, QWIDTH, QHEIGHT, QBORDER,
			BlackPixel(d, screen), WhitePixel(d, screen));
    Tup[0] = XCreateSimpleWindow(d, w, 4, 40,
			TWIDTH, THEIGHT, TBORDER,
			WhitePixel(d, screen), bg_pixel);
    Tup[1] = XCreateSimpleWindow(d, w, WIDTH - TWIDTH - 4 - TBORDER * 2, 40,
			TWIDTH, THEIGHT, TBORDER,
			WhitePixel(d, screen), bg_pixel);
    tc.red = 0; tc.green = 0xffff; tc.blue = 0xffff;
    XAllocColor(d, cmap, &tc);
    pg[0] = XCreateSimpleWindow(d, Tup[0], 0, THEIGHT *3 /4,
			TWIDTH -12, THEIGHT /4 -12, 6, tc.pixel, bg_pixel);
    tc.red = 0xffff; tc.green = 0xffff; tc.blue = 0;
    XAllocColor(d, cmap, &tc);
    pg[1] = XCreateSimpleWindow(d, Tup[1], 0, THEIGHT *3 /4,
			TWIDTH -12, THEIGHT /4 -12, 6, tc.pixel, bg_pixel);
    wf = XCreateSimpleWindow(d, w,
			((WIDTH / 2 - TWIDTH - 4 - TBORDER * 2) * 2
				- WFWIDTH - WFBORDER) / 2 + TWIDTH, 40,
			WFWIDTH, WFHEIGHT, WFBORDER,
			WhitePixel(d, screen), bg_pixel);

    XStoreName(d, w, TITLE);

    mountain = XCreatePixmap(d, w, WIDTH, HEIGHT / 2, DefaultDepth(d, screen));

    tc.red = 0; tc.green = 0xe000; tc.blue = 0;
    XAllocColor(d, cmap, &tc);
    XSetForeground(d, gcM, tc.pixel);
    mpixel = tc.pixel;

    tc.red = 0xffff; tc.green = 0xffff; tc.blue = 0xffff;
    XAllocColor(d, cmap, &tc);
    XSetForeground(d, gcP, tc.pixel);

    tc.red = 0; tc.green = 0xffff; tc.blue = 0xffff;
    XAllocColor(d, cmap, &tc);
    XSetForeground(d, gc, tc.pixel);
    PtorideL = XCreatePixmapFromBitmapData(d, w,
				torideL_bits, torideL_width, torideL_height,
				tc.pixel, bg_pixel, DefaultDepth(d, screen));
    tc.red = 0xffff; tc.green = 0xffff; tc.blue = 0;
    XAllocColor(d, cmap, &tc);
    XSetForeground(d, gc, tc.pixel);
    PtorideR = XCreatePixmapFromBitmapData(d, w,
			torideR_bits, torideR_width, torideR_height,
			tc.pixel, bg_pixel, DefaultDepth(d, screen));

    XMapWindow(d, w);
    XSync(d, False);

    for(;;) {
	/* ȥǤ */
	xtoride(quit, Tup, pg, PtorideL, PtorideR, &QuitFlag, mpixel);
    }
}


/*  */
void
xtoride(quit, Tup, pg, PtorideL, PtorideR, QuitFlag, mpixel)
    Window		quit, *Tup, *pg;
    Pixmap		PtorideL, PtorideR;
    unsigned short	*QuitFlag;
    unsigned long	mpixel;
{
    XEvent	event;
    GC		gc;
    double	tx[2], ty[2];		/* ˤƤκɸ ֤ (-1, -1) */
    double	vx[2], vy[2];		/* ˤƤΰư */
    double	wind, windc;		/* ®, Ѳ */
    int		angle[2], velocity[2];	/* ͽг, ® */
    int		a_max[2], a_min[2];	/* ͽг٤ϰ */
    int		v_max, v_min;		/* ®ϰ */
    int		tmp, i;			/*  */
    char	cflag, sflag;		/* cflag: 	sflag: ͽ
					 * b7-6: 		b7-6: ̤
					 * b5-4: ®		b5: ȯ
					 * b3-2: 		b4: ͽ
					 * b1-0: ®		b3-2: ̤
					 * 00: ̵Ѳ		b1: ȯ
					 * 01: -1		b0: ͽ
					 * 10: +1
					 * 11: ̵Ѳ
					 */
    char	rflag;		/* ե饰 
				 * b7-b2: ̤
				 * b1: ץ쥤Ϥ
				 * b0: ɽ
				 */

    gc	= XCreateGC(d, root, 0, NULL);

    tx[0] = tx[1] = ty[0] = ty[1] = -1;
    vx[0] = vx[1] = vy[0] = vy[1] =  0;
    wind	= (double)rand() / RAND_MAX * 6 - 3;
    windc	=    0;
    angle[0]    =   45;	angle[1]    = 135;
    velocity[0]	=    1;	velocity[1] =   1;
    a_max[0]    =  120;	a_max[1]    = 180;
    a_min[0]    =    0;	a_min[1]    =  60;
    v_max	= PMAX;	v_min	    =   1;
    cflag = 0x00;
    sflag = 0x00;
    rflag = 0x00;

    /* globalѿ */
    bstage[0] = bstage[1] = -1;

    XMapWindow(d, wf);
    XMapWindow(d, quit);
    XSelectInput(d, w,	    ExposureMask | KeyPressMask | KeyReleaseMask);
    XSelectInput(d, wf,	    ExposureMask);
    XSelectInput(d, quit,   ExposureMask | ButtonPressMask
			    | EnterWindowMask | LeaveWindowMask);

    for (i = 0; i <= 1; i++) {
	XMapWindow(d, *(Tup + i));
	XMapWindow(d, *(pg + i));
	XSelectInput(d, *(Tup + i), ExposureMask);
	XSelectInput(d, *(pg + i), ExposureMask);
    }

    XSetForeground(d, gc, bg_pixel);
    XFillRectangle(d, mountain, gc, 0, 0, WIDTH, HEIGHT / 2);
    CreateStage();
    DrawStage(PtorideL, PtorideR, sflag);
    DrawQuitButton(quit, *QuitFlag);
    DrawTorideUp(*(Tup    ), 0, angle[0], 0);
    DrawTorideUp(*(Tup + 1), 0, angle[1], 1);
    DrawPowerGauge(*(pg    ), velocity[0], 0);
    DrawPowerGauge(*(pg + 1), velocity[1], 1);
    DrawFlag(wind);

    UALARM(1);

    for (;;) {
	sleep(999999);
	while (XPending(d)) {
	    XNextEvent(d, &event);
	    if (event.xany.window == quit)
		QuitButton(quit, &event, QuitFlag);
	    if (event.xany.window == wf)
		DrawFlag(wind);
	    for (i = 0; i <= 1; i++) {
		if (event.xany.window == *(Tup + i))
		    DrawTorideUp(*(Tup + i), 0, angle[i], i);
		if (event.xany.window == *(pg + i))
		    DrawPowerGauge(*(pg + i), velocity[i], i);
	    }

	    if (event.xany.window == w) {
		if (event.type == Expose) {
		    DrawStage(PtorideL, PtorideR, sflag);
		    if (rflag & 0x01)
			theEnd(sflag);
		} else if (event.type == KeyPress)
		    KeyHandler(&event.xkey, event.type, &cflag, &sflag, &rflag);
		else if (event.type == KeyRelease)
		    KeyHandler(&event.xkey, event.type, &cflag, &sflag, &rflag);
	    }
	} /* while (XPending(d)) */

	for (i = 0; i <= 1; i++) {
	    if (sflag & 0x10 >> i * 4 && tx[i] + ty[i] == -2) {
		tx[i]	=   toride[i].x + 8;
		ty[i]	=   toride[i].y - 9;
		vx[i]	=   velocity[i] * cos(angle[i] * RAD);
		vy[i]	= - velocity[i] * sin(angle[i] * RAD);
	    }

	    tmp	= (angle[i] < a_max[i]
			? ((cflag >> (1 - i) * 4 + 3) & 1) : 0)
		 - (angle[i] > a_min[i]
			? ((cflag >> (1 - i) * 4 + 2) & 1) : 0);
	    if (tmp != 0) {
		DrawTorideUp(*(Tup + i), angle[i], angle[i] + tmp, i);
		angle[i]	+= tmp;
	    }
	    tmp	= (velocity[i] < v_max
			? ((cflag >> (1 - i) * 4 + 1) & 1) : 0)
		 - (velocity[i] > v_min
			? ((cflag >> (1 - i) * 4    ) & 1) : 0);
	    if (tmp != 0) {
		velocity[i]	+= tmp;
		DrawPowerGauge(*(pg + i), velocity[i], i);
	    }
	}
	
	MoveShell(tx, ty, vx, vy, wind, mpixel, &sflag);
	if ((double)rand() / RAND_MAX < WINDCP && (rflag & 0x01) == 0)
	    Wind(&wind, &windc);
	if ((sflag & 0x22) != 0 && tx[0] == -1 && ty[0] == -1
				&& tx[1] == -1 && ty[1] == -1) {
	    if ((rflag & 0x01) == 0) {
		/* UALARM(0);*/
		theEnd(sflag);
	    }
	    rflag |= 0x01;
	    if ((rflag & 0x02) != 0)
		break;
	}
    }    /* for(;;) */

    UALARM(0);
    XUnmapWindow(d, quit);
    XUnmapWindow(d, *(Tup + 0));
    XUnmapWindow(d, *(Tup + 1));
    XUnmapWindow(d, *(pg + 0));
    XUnmapWindow(d, *(pg + 1));
    XUnmapWindow(d, wf);
    XClearWindow(d, w);
}


/* ɽ */
void
theEnd(sflag)
    char	sflag;
{
    XColor	tc;
    GC		gc;
    Font	font;
    char	*words[] = {" Cyan Won! ", "Yellow Won!", " Draw Game "};

    gc	= XCreateGC(d, root, 0, NULL);

    tc.red	= 0xffff *  ((sflag & 0x20) >> 5);
    tc.green	= 0xffff * (((sflag & 0x20) >> 5) ^ ((sflag & 0x02) >> 1));
    tc.blue	= 0xffff *  ((sflag & 0x02) >> 1);
    XAllocColor(d, cmap, &tc);
    XSetForeground(d, gc, tc.pixel);

    font	= XLoadFont(d, "lucidasans-bolditalic-24");
    XSetFont(d, gc, font);
    XDrawString(d, w, gc, (WIDTH - 164) / 2, (HEIGHT + 20)/ 2,
		words[((sflag & 0x20) >> 4) + ((sflag & 0x02) >> 1) - 1], 11);
    XFlush(d);
}


/* ߥϥɥ */
void
al_handler(sig)
    int sig;
{
}
